<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>

  <body>
    <div class="container">
      <h2>Registration Car Form</h2>

      <div class="jumbotron container">
        <div class="row form-group">
          <div class="col-sm-3">
            <label for="input-fname">First Name</label>
          </div>
          <div class="col-sm-9">
            <input
              type="text"
              id="input-fname"
              name="firstname"
              placeholder="Your first name ..."
              class="form-control"
            />
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-3">
            <label for="input-lname">Last Name</label>
          </div>
          <div class="col-sm-9">
            <input
              type="text"
              id="input-lname"
              name="lastname"
              placeholder="Your last name ..."
              class="form-control"
            />
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-3">
            <label for="country-select">Country</label>
          </div>
          <div class="col-sm-3">
            <select id="country-select" name="country" class="form-control">
            </select>
          </div>
          <div class="col-sm-3">
            <label for="region-type-select">Region</label>
          </div>
          <div class="col-sm-3">
            <select
              id="region-type-select"
              disabled
              name="region"
              class="form-control"
            >
            </select>
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-3">
            <label for="car-select">Car</label>
          </div>
          <div class="col-sm-3">
            <select id="car-select" name="car" class="form-control"> </select>
          </div>
          <div class="col-sm-3">
            <label for="car-type-select">Car type</label>
          </div>
          <div class="col-sm-3">
            <select
              id="car-type-select"
              name="car-type"
              disabled
              class="form-control"
            >
            </select>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12" style="text-align: right;">
            <button class="btn btn-info" id="btn-send">Send</button>
          </div>
        </div>
      </div>
    </div>
  </body>

  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // car brand information
    var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;

    // country information
    var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;

    var gObjectCarData = JSON.parse(gJsonCarData);
    var gObjectCountryData = JSON.parse(gJsonCountryData);

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    $("#car-select").on("change", function () {
      onSelectCarChange();
    });
    $("#btn-send").on("click", function () {
      onBtnSendClick();
    });

    $("#country-select").on("change", function () {
      onSelectCountryChange();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm xử lý khi click nút send
    function onBtnSendClick() {
      "use strict";
      var vCountryId = $("#car-select option:selected").val();
      var vBrandName = $("#car-select option:selected").text();

      var vTypeId = $("#car-type-select option:selected").val();
      var vTypeName = $("#car-type-select option:selected").text();

      console.log("Ta có brandId: " + vCountryId);
      console.log("Ta có brandName: " + vBrandName);
      console.log("Ta có TypeId: " + vTypeId);
      console.log("Ta có TypeName: " + vTypeName);

      //for Country
      var vCountryId = $("#country-select option:selected").val();
      var vCountryName = $("#country-select option:selected").text();

      var vRegionId = $("#region-type-select option:selected").val();
      var vRegionName = $("#region-type-select option:selected").text();

      console.log("Ta có countryId: " + vCountryId);
      console.log("Ta có countryName: " + vCountryName);
      console.log("Ta có regionId: " + vRegionId);
      console.log("Ta có regionName: " + vRegionName);
    }
    // Hàm xử lý khi tải trang
    function onPageLoading() {
      "use strict";
      console.log("Đã tải trang!");
      for (var bI = 0; bI < gObjectCarData.length; bI++) {
        $("#car-select").append(
          $("<option>", {
            value: gObjectCarData[bI].brandId,
            text: gObjectCarData[bI].brandName,
          })
        );
      }

      for (var bI = 0; bI < gObjectCountryData.length; bI++) {
        $("#country-select").append(
          $("<option>", {
            value: gObjectCountryData[bI].countryId,
            text: gObjectCountryData[bI].countryName,
          })
        );
      }
    }

    // Hàm xử lý khi change option
    function onSelectCarChange() {
      "use strict";
      var vBrandID = $("#car-select").val();
      console.log("Ta có giá trị brandId vừa chọn là: " + vBrandID);
      var vBrandTypeSelectCar = getBrandTypeByBrandID(vBrandID);
      console.log(vBrandTypeSelectCar);

      $("#car-type-select").empty(); // Làm rỗng dữ liệu select trước khi append
      if (vBrandTypeSelectCar.length > 0) {
        // Nếu có dữ liệu brandType thì tiến hành append dữ liệu vào ô select car type
        for (var bI = 0; bI < vBrandTypeSelectCar.length; bI++) {
          $("#car-type-select").append(
            $("<option>", {
              value: vBrandTypeSelectCar[bI].typeId,
              text: vBrandTypeSelectCar[bI].typeName,
            })
          );
        }

        $("#car-type-select").removeAttr("disabled");
      } else {
        // Ngược lại thêm thuộc tính disabled cho select car type
        $("#car-type-select").prop("disabled", "disabled");
      }
    }

    // Hàm xử lý khi change option
    function onSelectCountryChange() {
      "use strict";
      var vCountryID = $("#country-select").val();
      console.log("Ta có giá trị countryId vừa chọn là: " + vCountryID);
      var vRegionTypeSelectCountry = getRegionTypeByCountryID(vCountryID);
      console.log(vRegionTypeSelectCountry);

      $("#region-type-select").empty(); // Làm rỗng dữ liệu select trước khi append
      if (vRegionTypeSelectCountry.length > 0) {
        // Nếu có dữ liệu regionType thì tiến hành append dữ liệu vào ô select Region
        for (var bI = 0; bI < vRegionTypeSelectCountry.length; bI++) {
          $("#region-type-select").append(
            $("<option>", {
              value: vRegionTypeSelectCountry[bI].regionId,
              text: vRegionTypeSelectCountry[bI].regionName,
            })
          );
        }

        $("#region-type-select").removeAttr("disabled");
      } else {
        // Ngược lại thêm thuộc tính disabled cho select Region
        $("#region-type-select").prop("disabled", "disabled");
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    /**
     * get brandType by brandId
     * input: brandId of a car
     * output: brandType name of found car. If not found, it returns null
     */
    function getBrandTypeByBrandID(paramBrandId) {
      var vBrandFound = false;
      var vBrandTypesResult = null;
      var vIterator = 0;
      while (!vBrandFound && vIterator < gObjectCarData.length) {
        if (gObjectCarData[vIterator].brandId === paramBrandId) {
          vBrandFound = true;
          vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
        } else {
          vIterator++;
        }
      }
      return vBrandTypesResult;
    }

    /**
     * get regionType by CountryId
     * input: CountryId
     * output: regionType of found country. If not found, it returns null
     */
    function getRegionTypeByCountryID(paramCountryId) {
      var vCountryFound = false;
      var vRegionTypesResult = null;
      var vIterator = 0;
      while (!vCountryFound && vIterator < gObjectCountryData.length) {
        if (gObjectCountryData[vIterator].countryId === paramCountryId) {
          vCountryFound = true;
          vRegionTypesResult = gObjectCountryData[vIterator].regionTypes;
        } else {
          vIterator++;
        }
      }
      return vRegionTypesResult;
    }
  </script>
</html>
